﻿using System;
using System.Diagnostics;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using Infragistics.Controls.Grids;

namespace CustomContolTest
{
    //public class CustomBehaviour : Behavior<TextBox>
    //{
    //    protected override void OnAttached()
    //    {
    //        base.OnAttached();

    //        AssociatedObject.TextChanged += AssociatedObjectOnTextChanged;
    //    }

    //    private void AssociatedObjectOnTextChanged(object sender, TextChangedEventArgs textChangedEventArgs)
    //    {
    //        Debug.WriteLine("------------------------------");
    //    }
    //}


    public class CustomCellControlBehaviour : Behavior<CellControl>
    {
        private bool IsDoubleClicked { get; set; }
        public XamGrid XamGrid { get; set; }
        public int ClickCount { get; set; }


        protected override void OnAttached()
        {
            base.OnAttached();

            var parrent = Helper.FindParent<XamGrid>(AssociatedObject);

            if (parrent != null && AssociatedObject !=null)
            {
                XamGrid = parrent;
                AssociatedObject.MouseDoubleClick += AssociatedObjectOnMouseDoubleClick;
                XamGrid.CellClicked += XamGridOnCellClicked;
            }

        }

        protected override void OnDetaching()
        {
            base.OnDetaching();

            if (XamGrid != null && AssociatedObject != null)
            {
                AssociatedObject.MouseDoubleClick -= AssociatedObjectOnMouseDoubleClick;
                //XamGrid.CellEnteringEditMode -= ParrentOnCellEnteringEditMode;
                XamGrid.CellClicked -=  XamGridOnCellClicked;
            }
        }

        private async void XamGridOnCellClicked(object sender, CellClickedEventArgs cellClickedEventArgs)
        {
            ClickCount++;
            if (ClickCount > 1)
            {
               return;
            }
            if (IsDoubleClicked)
            {
                IsDoubleClicked = false;
                return;
            }

            await Task.Delay(500);

            if (ClickCount > 1 && XamGrid.ActiveCell == AssociatedObject.Cell)
            {
                XamGrid.EnterEditMode(XamGrid.ActiveCell);
                ClickCount = 0; ;
                IsDoubleClicked = false;
                return;
            }
            ClickCount = 0;
          
        }

        private async void ParrentOnCellEnteringEditMode(object sender, BeginEditingCellEventArgs beginEditingCellEventArgs)
        {

          
            if (IsDoubleClicked)
            {
                IsDoubleClicked = false;
                beginEditingCellEventArgs.Cancel = true;
                return;
            }

            await Task.Delay(500);

           

        }

        private void AssociatedObjectOnMouseDoubleClick(object sender, MouseButtonEventArgs mouseButtonEventArgs)
        {
            IsDoubleClicked = true;
        }

        private void AssociatedObjectOnMouseMove(object sender, MouseEventArgs mouseEventArgs)
        {
            Debug.WriteLine(Guid.NewGuid().ToString("N"));
        }

    }

    class Helper
    {
        public static T FindParent<T>(DependencyObject child) where T : DependencyObject
        {
            //get parent item
            DependencyObject parentObject = VisualTreeHelper.GetParent(child);

            //we've reached the end of the tree
            if (parentObject == null) return null;

            //check if the parent matches the type we're looking for
            T parent = parentObject as T;
            if (parent != null)
                return parent;
            else
                return FindParent<T>(parentObject);
        }
    }
}