﻿using System;
using System.Collections;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Controls.Grids;

namespace CustomContolTest
{
    [TemplatePart(Name="PART_XamGrid", Type = typeof(XamGrid))]
    public class CustomControl : Control
    {
        static CustomControl()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(CustomControl), new FrameworkPropertyMetadata(typeof(CustomControl)));
        }

        public static readonly DependencyProperty CustopPropCellStyleProperty =
            XamGrid.CellStyleProperty.AddOwner(typeof(CustomControl));

        public Style CustopPropCellStyle
        {
            get { return (Style) GetValue(CustopPropCellStyleProperty); }
            set { SetValue(CustopPropCellStyleProperty, value); }
        }


        public static readonly DependencyProperty EnumerableProperty = DependencyProperty.Register(
            "Enumerable", typeof(IEnumerable), typeof(CustomControl), new PropertyMetadata(default(IEnumerable)));

        public IEnumerable Enumerable
        {
            get { return (IEnumerable) GetValue(EnumerableProperty); }
            set { SetValue(EnumerableProperty, value); }
        }
    }
}
